000100 IDENTIFICATION DIVISION.
000200 PROGRAM-ID. LOADER.
000300********************* LOADER.CBL *************************************
000400** THIS PROGRAM LOADS THE INDEXED FILE FILESTAT2.DAT WITH FILE STATUS
000500** INFORMATION FOUND IN THE FILE FSTAT2.CBL.
000600**********************************************************************
000700 ENVIRONMENT DIVISION.
000800 CONFIGURATION SECTION.
000900 SOURCE-COMPUTER. IBM-PC.
001000 OBJECT-COMPUTER. IBM-PC.
001100 INPUT-OUTPUT SECTION.
001200 FILE-CONTROL.
001300 SELECT DATAFILE ASSIGN TO "FSTAT2.CBL"
001400 ORGANIZATION IS LINE SEQUENTIAL
001500 FILE STATUS IS WS-STATUS.
001600 SELECT LOADFILE ASSIGN TO "FSTAT2.DAT"
001700 ORGANIZATION IS INDEXED
001800 ACCESS IS SEQUENTIAL
001900 RECORD KEY IS CODE-KEY
002000 FILE STATUS IS LOAD-STATUS.
002100 DATA DIVISION.
002200 FILE SECTION.
002300 FD DATAFILE
002400     RECORD CONTAINS 77 CHARACTERS
002500     DATA RECORD IS DATA-REC.
002600 01 DATA-REC.
002700     05 DESC-OUT            PIC X(72).
002800     05                     PIC X.
002900     05 CODE-OUT            PIC X(4).
003000 FD LOADFILE
003100     DATA RECORD IS LOAD-REC.
003200 01 LOAD-REC.
003300     05 DESC-IN             PIC X(72).
003400     05                     PIC X.
003500     05 CODE-KEY            PIC X(4).
003600 WORKING-STORAGE SECTION.
003700 01 WS-STATUS.
003800     05 WS-1                PIC X.
003900     05 WS-2                PIC X.
004000 01 LOAD-STATUS.
004100     05 LS-1                PIC X.
004200     05 LS-2                PIC X.
004300 01 SWITCH                  PIC X(3) VALUE "YES".
004400     88 NO-MORE-RECORDS     VALUE " NO".
004500 PROCEDURE DIVISION.
004600 000-MAIN.
004700     PERFORM 100-OPEN.
004800     PERFORM 200-READER UNTIL NO-MORE-RECORDS.
004900     PERFORM 999-ENDER.
005000 100-OPEN.
005100     OPEN INPUT DATAFILE.
005200     IF WS-STATUS NOT = "00"
005300     DISPLAY "OPEN OF DATAFILE DID NOT WORK " WS-STATUS
005400     PERFORM 999-ENDER.
005500     OPEN OUTPUT LOADFILE.
005600     IF LOAD-STATUS NOT = "00"
005700     DISPLAY "OPEN OF LOADFILE DID NOT WORK " LOAD-STATUS
005800     PERFORM 999-ENDER.
005801     READ DATAFILE AT END MOVE " NO" TO SWITCH.
005805     DISPLAY "OUT CODE IS " CODE-OUT.
005810 200-READER.
005850     WRITE LOAD-REC FROM DATA-REC.
005851     DISPLAY "INPUT IS    " CODE-KEY.
005860     READ DATAFILE AT END MOVE " NO" TO SWITCH.
005862     DISPLAY "OUT CODE IS " CODE-OUT.
005900 999-ENDER.
006000    CLOSE DATAFILE.
006100    CLOSE LOADFILE.
006200    STOP RUN.
